https://leetcode-cn.com/problems/linked-list-cycle-ii/
思路:
看到这个题,最容易想到就是如果能对节点做标记,那遍历链表时第一个被标记两次的节点肯定就是第一个环节点了。但是题目要求不能修改给定链表,也不让使用额外空间,这样说来,肯定是有技巧的。先考虑双指针遍历。
双指针法
一个指针一次走一步,一个指针一次走两步。如果链表有环的话,两个指针肯定会相遇。如果没有环,走得快的指针先到链表尾部,结束遍历即可。
有环的情况,给两个指针a,b,a一次走两个节点距离,b一次走一个节点距离。设链表起点到环起点的距离是m,环起点到相遇节点的距离是n,圆环的周长为L。我们要求的就是m。如下图所示:

可以得出这样的公式:
2(m+n) = m+n + kL
则 m+n=kL
m=kL-n
, 其中 k>=1
当然,此时m,n,L未知。
此时在用一个指针c 从链表头开始走,指针b从a,b相遇点开始走,同时记下走的步数。因为m=kL-n,所以b,c再走m步刚好相遇。返回m。
看网上有人的解法直接将k视为1,这样不够严谨啊!